import os
from tqdm import tqdm
import numpy as np
import matplotlib.pyplot as plt
import sys

sys.path.insert(0, '../')

from utils import isARawImage, Color, getColorChannel, mergeSingleColorChannelImagesAccordingToBayerFilter, iterativeMean

folder = '../rafael/230424'
meanImages = iterativeMean()
filePaths = [f'{folder}/{file}' for file in os.listdir(folder) if isARawImage(file)]

for filePath in tqdm(filePaths):
    imageColorChannels = {color: getColorChannel(filePath, color) for color in Color}
    imageMergedColorChannels = mergeSingleColorChannelImagesAccordingToBayerFilter(imageColorChannels)
    meanImages.add(imageMergedColorChannels)

#print(meanImages.mean.shape)

# Is not there anything clever than this to do? See [Robust_image_source_identification_on_modern_smartphones/issues/72](https://gitea.lemnoslife.com/Benjamin_Loison/Robust_image_source_identification_on_modern_smartphones/issues/72).
estimatedPrnu = iterativeMean()
for filePath in tqdm(filePaths):
    imageColorChannels = {color: getColorChannel(filePath, color) for color in Color}
    imageMergedColorChannels = mergeSingleColorChannelImagesAccordingToBayerFilter(imageColorChannels)
    estimatedPrnu.add(imageMergedColorChannels - meanImages.mean)

plt.imshow(estimatedPrnu.mean)
plt.show()